// BrowseForFolder.cpp: CBrowseForFolder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "rnddrag.h"
#include "BrowseForFolder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CBrowseForFolder::CBrowseForFolder(HWND hWnd,CString strDefaultFolder)
{
	m_hWnd = hWnd;
	m_strDefaultFolder = strDefaultFolder;
}

CBrowseForFolder::~CBrowseForFolder()
{

}

// http://www3.freeweb.ne.jp/misc/kmiwaki/developer/tips/shbrowseforfolderex.shtml
int CALLBACK BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lParam , LPARAM lpData)
{
	CBrowseForFolder* pThis = (CBrowseForFolder*)lpData;

	switch (uMsg)
	{
		case BFFM_INITIALIZED:
			// wParam  TRUE  ȂpX
			//           FALSE Ȃpidl
			SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)((LPCTSTR)pThis->m_strDefaultFolder));
			break;
		default:
			break;
	}
	return 0;
}

// http://www3.freeweb.ne.jp/misc/kmiwaki/developer/tips/shbrowseforfolderex.shtml
BOOL CBrowseForFolder::DoModal()
{
	int bResult = IDCANCEL;
	BROWSEINFO bi;
	TCHAR szDir[MAX_PATH];
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;
	
	if (SUCCEEDED(SHGetMalloc(&pMalloc))) 
	{
		ZeroMemory(&bi,sizeof(bi));
		bi.hwndOwner = m_hWnd;
		bi.pidlRoot = 0;
		bi.pszDisplayName = 0;
		bi.lpszTitle = "Select folder";
		bi.ulFlags = BIF_RETURNONLYFSDIRS;
		bi.lpfn = BrowseCallbackProc;
		bi.lParam = (long)this;
		
		pidl = SHBrowseForFolder(&bi);
		
		if (pidl) 
		{
			if (SHGetPathFromIDList(pidl,szDir)) 
			{
				// ɃtH_Iꂽ̏LqĂB
				m_strPath = szDir;
				bResult = IDOK;
			}
			
			pMalloc->Free(pidl);
			pMalloc->Release();
		}
	}

	return bResult;
}
